import dds
import ddsutil
import std_msgs/msg/Header_.std_msgs.msg.dds_
import struct

class Vector3Stamped___TypeSupport(dds.TypeSupport):

    _typename = 'geometry_msgs::msg::dds_::Vector3Stamped_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="Vector3_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member></Struct></Module></Module></Module><Module name="builtin_interfaces"><Module name="msg"><Module name="dds_"><Struct name="Time_"><Member name="sec_"><Long/></Member><Member name="nanosec_"><ULong/></Member></Struct></Module></Module></Module><Module name="std_msgs"><Module name="msg"><Module name="dds_"><Struct name="Header_"><Member name="stamp_"><Type name="::builtin_interfaces::msg::dds_::Time_"/></Member><Member name="frame_id_"><String/></Member></Struct></Module></Module></Module><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="Vector3Stamped_"><Member name="header_"><Type name="::std_msgs::msg::dds_::Header_"/></Member><Member name="vector_"><Type name="Vector3_"/></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(Vector3Stamped___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(Vector3Stamped_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, Vector3Stamped_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = Vector3Stamped_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class Vector3Stamped_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return Vector3Stamped___TypeSupport()

    @property
    def header_(self):
        '''
        a DDS std_msgs::msg::dds_::Header_ value
        @rtype: std_msgs/msg/Header_.std_msgs.msg.dds_.Header_
        '''
        return self._header__

    _header__checker = ddsutil._class_checker(std_msgs/msg/Header_.std_msgs.msg.dds_.Header_)
    @header_.setter
    def header_(self, value):
        self._header__checker(value)
        self._header__ = value

    @property
    def vector_(self):
        '''
        a DDS geometry_msgs::msg::dds_::Vector3_ value
        @rtype: Vector3_
        '''
        return self._vector__

    _vector__checker = ddsutil._class_checker(Vector3_)
    @vector_.setter
    def vector_(self, value):
        self._vector__checker(value)
        self._vector__ = value

    _member_attributes = ('header_', 'vector_')

    def __init__(self, **kwargs):
        ''' Create a Vector3Stamped_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()
        self.vector_ = Vector3_()
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if Vector3Stamped_._packing_fmt is not None:
            return Vector3Stamped_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, std_msgs/msg/Header_.std_msgs.msg.dds_.Header_._get_packing_fmt())
        fmt += ddsutil._align(fmt, Vector3_._get_packing_fmt())

        Vector3Stamped_._packing_fmt = ddsutil._pad_fmt(fmt)
        return Vector3Stamped_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()._deserialize(data)
        self.vector_ = Vector3_()._deserialize(data)
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.header_._get_packing_args())
        args.extend(self.vector_._get_packing_args())
        return args

